/* Petter Schau 1996
// io prototypes for use outside ioa.c/io.h
*/
extern int unlock_region (void *address, unsigned length);
extern int lock_region (void *address, unsigned length);


extern ULO bufferoffsets[3];

extern void set_VGAcolor(UBY col,UBY b,UBY g,UBY r);

extern ULO fps;
extern void timerFPSCalculate(void);
extern void start_timerirq(void);
extern void stop_timerirq(void);
extern void addlog(char *msg);

extern UBY config_graphics_modebits[7];
extern ULO tick;
extern ULO tick2;

extern ULO newvmode;
extern void adderror(char *msg);

extern UBY config_graphics_modeavailable[7];

extern UBY graph256_palette[256][3];
extern ULO config_graphics_moderesx[NROFMODES];
extern ULO config_graphics_moderesy[NROFMODES];

extern void find_modes(void);

struct window {
  ULO x1,y1,x2,y2;
  UWO fgcolor;
  UWO bgcolor;
};

struct numberfield {
  ULO x,y;
  ULO value;
  struct window *hostwindow;
};

// Struct to hold string field data
// --------------------------------
struct stringfield {
  ULO x,y;
  char value[120];
  struct window *hostwindow;
};

void init_number_field(struct numberfield *n,struct window *w,ULO v,ULO x,ULO y);
void enter_number(struct numberfield *n);

void init_string_field(struct stringfield *n,struct window *w,ULO x,ULO y);
void enter_string(struct stringfield *n);

extern UWO *framebuffer;

extern ULO emulate_joystick;
extern ULO screeninit(void);
extern ULO screenclose(void);
extern void plot_text(char *str,ULO x,ULO y,UWO fgcol,UWO bgcol);
extern void plot_text_speedbuffer(char *str,UWO fgcol,UWO bgcol);
extern void clear(ULO starty, ULO stoppy);
extern void init_window(struct window *w,ULO x1,ULO y1,ULO x2,ULO y2,UWO fgcolor,UWO bgcolor);
extern void clear_window(struct window *w);
extern void plot_text_window(struct window *w,char *s,ULO x,ULO y);
extern void plot_text_window_reverse(struct window *w,char *s,ULO x,ULO y);
extern void print_window_borders(struct window *w);

extern ULO firebutton;
extern void set_mode320200oldvga(void);
extern void set_mode320200w(void);
extern void set_mode320240w(void);
extern void set_mode320400w(void);
extern void set_mode320480w(void);
extern void set_mode400300w(void);
extern void set_mode320240b(void);
extern void set_mode320400b(void);
extern void set_mode320480b(void);
extern void set_mode400300b(void);
extern void set_mode800600w(void);
extern void set_mode640480w(void);
extern void set_mode640400w(void);
extern void set_mode640350w(void);
extern void vesa_scaley(void);
